/****************************************************************************
**
** Copyright (C) 2004-2006 Trolltech ASA. All rights reserved.
**
** This file is part of the demonstration applications of the Qt Toolkit.
**
** Licensees holding valid Qt Preview licenses may use this file in
** accordance with the Qt Preview License Agreement provided with the
** Software.
**
** See http://www.trolltech.com/pricing.html or email sales@trolltech.com for
** information about Qt Commercial License Agreements.
**
** Contact info@trolltech.com if any conditions of this licensing are
** not clear to you.
**
** This file is provided AS IS with NO WARRANTY OF ANY KIND, INCLUDING THE
** WARRANTY OF DESIGN, MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
**
****************************************************************************/

#include "popupwidget.h"

#include <QtGui>

PopupWidget::PopupWidget(QWidget *parent)
    :QWidget(parent, Qt::Popup), childWidget(0),
    eventLoop(0), returnCode(QDialog::Rejected)
{
}

PopupWidget::~PopupWidget()
{
     if(eventLoop)
        delete eventLoop;
}

void PopupWidget::setWidget(QWidget * widget)
{
    childWidget = widget;
    QVBoxLayout *widgetLayout = new QVBoxLayout(this);
    widgetLayout->setMargin(0);
    widgetLayout->addWidget(childWidget);
}

QWidget* PopupWidget::widget() const
{
    return childWidget;
}

int PopupWidget::exec(const QRect& rect)
{
    returnCode = QDialog::Rejected;
    move(rect.bottomLeft());
    show();
    if(!eventLoop)
        eventLoop = new QEventLoop;
    eventLoop->exec();
    return returnCode;
}

void PopupWidget::closePopup()
{
    returnCode = QDialog::Accepted;
    hide();
    if(eventLoop)
        eventLoop->exit();
}

void PopupWidget::hideEvent(QHideEvent *)
{    
    if(eventLoop)
        eventLoop->exit();
}

